Main Page Namespace List Class Hierarchy Alphabetical List Compound List Namespace Members Compound Members Related Pages

# Composition::KeyC Class Reference

Keyframe class for controller. More...

`#include <KeyC.h>`

Inheritance diagram for Composition::KeyC:

List of all members.

## Public Methods

- virtual Edit::DataBlockI* create ()
- virtual Edit::DataBlockI* create ( Edit::EditableI* pOriginal )
- virtual void copy ( Edit::DataBlockI* pBlock )
- virtual void restore ( Edit::EditableI* pEditable )
- virtual PajaTypes::int32 get_time ()
- virtual void set_time ( PajaTypes::int32 i32Time )
- virtual void set_flags ( PajaTypes::int32 i32Flags )
- virtual void add_flags ( PajaTypes::int32 i32Flags )
- virtual void del_flags ( PajaTypes::int32 i32Flags )
- virtual void toggle_flags ( PajaTypes::int32 i32Flags )
- virtual PajaTypes::int32 get_flags ()
- virtual PajaTypes::float32 get_ease_in ()
- virtual PajaTypes::float32 get_ease_out ()
- virtual PajaTypes::float32 get_tens ()
- virtual PajaTypes::float32 get_cont ()
- virtual PajaTypes::float32 get_bias ()
- virtual void set_ease_in ( PajaTypes::float32 )
- virtual void set_ease_out ( PajaTypes::float32 )
- virtual void set_tens ( PajaTypes::float32 )
- virtual void set_cont ( PajaTypes::float32 )
- virtual void set_bias ( PajaTypes::float32 )
- virtual void get_value ( PajaTypes::float32* pValues )
- virtual void set_value ( const PajaTypes::float32* pValues )
- virtual void get_in_tan ( PajaTypes::float32* pValues )
- virtual void set_in_tan ( const PajaTypes::float32* pValues )
- virtual void get_out_tan ( PajaTypes::float32* pValues )
- virtual void set_out_tan ( const PajaTypes::float32* pValues )
- virtual PajaTypes::uint32 save ( FileIO::SaveC* pSave )
- virtual PajaTypes::uint32 load ( FileIO::LoadC* pLoad )

## Static Public Methods

- KeyC* create_new ()
- KeyC* create_new ( PajaTypes::int32 i32NumChannels )

## Protected Methods

- KeyC ()
- KeyC ( PajaTypes::int32 i32Time )
- KeyC ( Edit::EditableI* pOriginal )
- virtual ~KeyC ()

## Detailed Description

Keyframe class for controller.

Key class defines the keys used in controllers. One key can have maximum of KEY_MAXCHANNELS channels. Currently the maximum number of channels is 4. All the channels in the key are floating point values.

This class is implemented by the system.

## Constructor & Destructor Documentation

KeyC ( | )`[protected]`

| Default constructor.

KeyC ( | PajaTypes::int32 i32Time )`[protected]`

| Creates new key and assign it the specified time.

KeyC ( | Edit::EditableI * pOriginal )`[protected]`

| Constructor with reference to the original.

~KeyC ( | )`[protected, virtual]`

| Default destructor.

## Member Function Documentation

void add_flags ( | PajaTypes::int32 i32Flags )`[virtual]`

| Sets only specified flags.

void copy ( | Edit::DataBlockI * pBlock )`[virtual]`

| Deep copy from a data block, see Edit::DataBlockI::copy(). Reimplemented from Edit::EditableI.

Edit::DataBlockI * create ( | Edit::EditableI * pOriginal )`[virtual]`

| Creates new file handle (used internally), see Edit::EditableI::create(). Reimplemented from Edit::EditableI.

Edit::DataBlockI * create ( | )`[virtual]`

| Create new key with zero no channels. Reimplemented from Edit::EditableI.

KeyC * create_new ( | PajaTypes::int32 i32NumChannels )`[static]`

| Create new key with specified number fo channels.

KeyC * create_new ( | )`[static]`

| Create new key with zero no channels.

void del_flags ( | PajaTypes::int32 i32Flags )`[virtual]`

| Removes only specified flags.

PajaTypes::float32 get_bias ( | )`[virtual]`

| Returns bias value.

PajaTypes::float32 get_cont ( | )`[virtual]`

| Returns continuity value.

PajaTypes::float32 get_ease_in ( | )`[virtual]`

| Returns ease in value.

PajaTypes::float32 get_ease_out ( | )`[virtual]`

| Returns ease out value.

PajaTypes::int32 get_flags ( | )`[virtual]`

| Returns key flags.

void get_in_tan ( | PajaTypes::float32 * pValues )`[virtual]`

| Returns the value of in-coming tangent. See also: get_value.

void get_out_tan ( | PajaTypes::float32 * pValues )`[virtual]`

| Returns the value of out-going tangent. See also: get_value.

PajaTypes::float32 get_tens ( | )`[virtual]`

| Returns tension value.

PajaTypes::int32 get_time ( | )`[virtual]`

| Returns the time of the key.

void get_value ( | PajaTypes::float32 * pValues )`[virtual]`

| Returns the value of the key. If the number of channels of the key isn't absolutely know the following method should be used to retrieve the value:
                float32 f32Values[KEY_MAXCHANNELS];
                pKey->get_value( f32Values );

PajaTypes::uint32 load ( | FileIO::LoadC * pLoad )`[virtual]`

| Serialize the key from a Demopaja input stream. Reimplemented from Edit::EditableI.

void restore ( | Edit::EditableI * pEditable )`[virtual]`

| Shallow copy from a editable, see Edit::EditableI::restore(). Reimplemented from Edit::EditableI.

PajaTypes::uint32 save ( | FileIO::SaveC * pSave )`[virtual]`

| Serialize the key to a Demopaja output stream. Reimplemented from Edit::EditableI.

void set_bias ( | PajaTypes::float32 )`[virtual]`

| Sets bias value.

void set_cont ( | PajaTypes::float32 )`[virtual]`

| Sets continuity value.

void set_ease_in ( | PajaTypes::float32 )`[virtual]`

| Sets ease in value.

void set_ease_out ( | PajaTypes::float32 )`[virtual]`

| Sets ease out value.

void set_flags ( | PajaTypes::int32 i32Flags )`[virtual]`

| Sets the effect flags. Be careful to use this method. There are some flags, which have to be in place to make the key work correctly. Use add, del or toggle flags methods instead.

void set_in_tan ( | const PajaTypes::float32 * pValues )`[virtual]`

| Sets in-coming tangent. See also: set_value.

void set_out_tan ( | const PajaTypes::float32 * pValues )`[virtual]`

| Sets out-going tangent. See also: set_value.

void set_tens ( | PajaTypes::float32 )`[virtual]`

| Sets tension value.

void set_time ( | PajaTypes::int32 i32Time )`[virtual]`

| Sets the time of the key.

void set_value ( | const PajaTypes::float32 * pValues )`[virtual]`

| Sets the value of the key. If the number of channels of the key isn't absolutely know the following method should be used to set the value:
                float32 f32Values[KEY_MAXCHANNELS];
                // Set values
                f32Values[0] = 10.0f;
                pKey->set_value( f32Values );

void toggle_flags ( | PajaTypes::int32 i32Flags )`[virtual]`

| Toggles only specified flags.

The documentation for this class was generated from the following file:

- KeyC.h